
#include <Lib/Functions.h>

/*
 * Signature must be on one line starting with "function" in C comment. 
 * Argument left parenthesis must stick the function name.
 */

extern "C" { double rmason_func(double a_xs[1],double a_params[8]); }

/*function(8)*/ double rmason_func(double a_xs[1],double a_params[8]) {
  double x = a_xs[0];

  double H = a_params[0];
  double M = a_params[1];
  double W = a_params[2];

  Lib::Function::Gaussian gauss(H,M,W);
  double A = a_params[3];
  double B = a_params[4];
  double C = a_params[5];
  Lib::Function::Cauchy   cauchy(A,B,C);

  std::vector<double> params;
  params.push_back(a_params[6]);
  params.push_back(a_params[7]);
  Lib::Function::Polynomial pol(params);

  return gauss.value(x)+cauchy.value(x)+pol.value(x);  
}
