#ifndef BatchLab_FunctionCatalog_h
#define BatchLab_FunctionCatalog_h

// Inheritance :
#include <AIDA/IFunctionCatalog.h>

namespace AIDA {
  class IFunction;
}

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Data {class IFunctionManager;}}
namespace Slash {namespace Data {class IFunction;}}

namespace BatchLab {

class FunctionCatalog : public virtual AIDA::IFunctionCatalog {
public: //AIDA/IFunctionCatalog
  virtual bool add(std::string,AIDA::IFunction*);
  virtual bool add(std::string,const std::string&);
  virtual std::vector<std::string> list();
  virtual void remove(const std::string&);
  virtual bool storeAll(const std::string&);
  virtual bool loadAll(const std::string&);
public:
  FunctionCatalog(Slash::Core::ISession&);
  virtual ~FunctionCatalog();
  Slash::Data::IFunction* find(const std::string& aFile,
                               const std::string& aModel);
private:
  bool loadFile(Slash::Data::IFunctionManager&,const std::string&);
private:
  Slash::Core::ISession& fSession;
};

}

#endif
