#ifndef BatchLab_FunctionFactory_h
#define BatchLab_FunctionFactory_h

// Inheritance :
#include <BatchLab/Core/BaseFactory.h>
#include <AIDA/IFunctionFactory.h>

namespace AIDA {
  class IFunction1D;
  class IFunction2D;
}

namespace Slash {namespace Core {class ISession;}}

namespace Slash {namespace Store {class ITree;}}

namespace BatchLab {

class FunctionFactory 
:public BaseFactory
,public virtual AIDA::IFunctionFactory 
{
public: //AIDA/IFunctionFactory
  virtual AIDA::IFunction* createFunctionByName(const std::string&,
                                                const std::string&);
  virtual AIDA::IFunction* createFunctionFromScript(const std::string&,
                                                    int,
                                                    const std::string&, 
                                                    const std::string&,
                                                    const std::string&,
                                                    const std::string& = "");
  /*FIXME  virtual AIDA::IFitFunction* createFit(const std::string&,
                                        const std::string&, 
                                        const std::string&, 
                                        const std::string&);
  */
  virtual AIDA::IFunction* cloneFunction(const std::string&,
                                         AIDA::IFunction&);

  virtual AIDA::IFunctionCatalog* catalog();
public:
  FunctionFactory(Slash::Core::ISession&,Slash::Store::ITree&);
  virtual ~FunctionFactory();
private:
  Slash::Core::ISession& fSession;
};

}

#endif
