#ifndef Lib_StreamBuffer_h
#define Lib_StreamBuffer_h

#include <Lib/strstream.h>

#include <string>

namespace Lib {

class StreamDestination {
public:
  virtual ~StreamDestination();
  virtual int receive(const std::string&);
};

class StreamBuffer : public streambuf {
public:
  StreamBuffer(StreamDestination*);
  virtual ~StreamBuffer();
  int overflow(int = EOF);
  int sync();
#ifdef WIN32
  int underflow();
#endif
  int receiveString();
private:
  StreamDestination* fDestination;
  char* fBuffer;
  int fCount;
  int fSize;
};

}
 
#endif
